#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "freetype/freetype.h"

#include "xwin.h"
#include "ftread.h"
#include "fileselector.h"
#include "rc.h"

char *textfile=0, *idxfile = 0;
char *fontfile = 0;
int fontsize = 10;
int font_is_freetype = 0, font_is_scalable = 0;
int sawhelp = 0;

main(int argc, char **argv)
{
  xinit();

  read_rc_file();

  if (argc > 1)
    {
      struct stat s;
      if (stat(argv[1], &s) >= 0)
	textfile = strdup(argv[1]);
      else
	argc = 0;
    }

  if (!textfile)
    textfile = strdup(file_selector(".txt"));

  if (!fontfile)
    fontfile = strdup("fixed");
  if (fontfile[0] == '/')
    font_is_freetype = 1;
  else
    {
      font_is_freetype = 0;
      if (strstr(fontfile, "-%d-"))
	font_is_scalable = 1;
    }

  if (fontsize < 4)
    fontsize = 4;
  if (fontsize > 99)
    fontsize = 99;

  if (argc > 1)
    {
      load_font();
      flow();
      /* intentionally don't write rc file here */
      write_rc_file(0);
      exit(0);
    }
  select_screen();

  write_rc_file(1);
}
