#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "ftread.h"
#include "rc.h"

static char *rcname;

void
read_rc_file()
{
  char *home = getenv("HOME");
  if (!home) home = "/";
  rcname = (char *)malloc (strlen(home) + strlen("/.ftreadrc") + 1);
  strcpy(rcname, home);
  strcat(rcname, "/.ftreadrc");
  FILE *rc = fopen(rcname, "r");
  if (rc)
    {
      char parm[100], val[1000];
      while (!feof(rc))
	{
	  parm[0] = val[0] = 0;
	  fscanf(rc, "%100s %1000[^\n]", parm, val);
	  if (strcmp(parm, "text") == 0)
	    {
	      if (textfile) free(textfile);
	      textfile = strdup(val);
	    }
	  if (strcmp(parm, "font") == 0)
	    {
	      if (fontfile) free(fontfile);
	      fontfile = strdup(val);
	    }
	  if (strcmp(parm, "size") == 0)
	    fontsize = atoi(val);
	  if (strcmp(parm, "sawhelp") == 0)
	    sawhelp = atoi(val);
	}
      fclose(rc);
    }
}

void
write_rc_file(int full)
{
  if (!full && access(rcname, R_OK) != 0)
    {
      FILE *rc = fopen(rcname, "w");
      fprintf(rc, "sawhelp 1\n");
      fclose(rc);
      return;
    }
  FILE *rc = fopen(rcname, "w");
  fprintf(rc, "text %s\n", textfile);
  fprintf(rc, "font %s\n", fontfile);
  fprintf(rc, "size %d\n", fontsize);
  if (sawhelp) fprintf(rc, "sawhelp %d\n", sawhelp);
  fclose(rc);
}
