#include <stdio.h>

#include <X11/Xlib.h>

main()
{
  Display *display = XOpenDisplay(0);
  int screen = XDefaultScreen(display);
  Window rootwin = XDefaultRootWindow(display);
  Colormap cmap = XDefaultColormap(display, screen);
  Window window;

  window = XCreateSimpleWindow(display,
			       rootwin,
			       0, 0,
			       160, 240,
			       0,
			       0,
			       WhitePixel(display, screen));

  XMapWindow (display, window);
  GC gc = XCreateGC(display, window, 0, 0);

  XSetWindowAttributes attributes;
  attributes.event_mask = (  ExposureMask
			   | ButtonPressMask
			   | KeyPressMask );
  XChangeWindowAttributes(display, window, CWEventMask, &attributes);

  Atom delete_atom = XInternAtom(display, "WM_DELETE_WINDOW", 0);
  Atom wm_protocols_atom = XInternAtom(display, "WM_PROTOCOLS", 0);

  XSetWMProtocols(display, window, &delete_atom, 1);

  XColor pix;
  int ts, bs = BlackPixel(display, screen), fg, bg = WhitePixel (display, screen);
  pix.red = pix.green = pix.blue = 0xd000;
  XAllocColor(display, cmap, &pix);
  ts = pix.pixel;

  pix.red = pix.green = pix.blue = 0x8000;
  XAllocColor(display, cmap, &pix);
  fg = pix.pixel;

  while (1)
    {
      XEvent event;
      XNextEvent(display, &event);
      printf("[event %d]\n", event.type);
      switch (event.type)
	{
	case Expose:
	  XSetForeground(display, gc, BlackPixel (display, screen));
	  XDrawLine (display, window, gc, 0, 0, 159, 239);
	  XDrawLine (display, window, gc, 0, 239, 159, 0);
	  XSetForeground(display, gc, ts);
	  XDrawLine (display, window, gc, 10, 10, 150, 10);
	  XDrawLine (display, window, gc, 10, 10, 10, 20);
	  XSetForeground(display, gc, bs);
	  XDrawLine (display, window, gc, 11, 20, 150, 20);
	  XDrawLine (display, window, gc, 150, 11, 150, 20);
	  XSetForeground(display, gc, fg);
	  XFillRectangle(display, window, gc, 11, 11, 139, 9);
	  break;
	case ClientMessage:
	  if (event.xclient.message_type == wm_protocols_atom
	      && event.xclient.data.l[0] == delete_atom)
	    exit(0);
	  break;
	}
    }
}
